package edu.ucf.rp2;

import java.util.List;

public class BingTester extends Tester {
	
	
	public BingTester () {
		this.logName = "Bing";
		this.maxSampleSize = Integer.MAX_VALUE;
	}
	
	
	public BingTester (String logName) {
		this.logName = logName;
		this.maxSampleSize = Integer.MAX_VALUE;
	}
	
	
	public BingTester (String logName, int maxSampleSize) {
		this.logName = logName;
		this.maxSampleSize = maxSampleSize;
	}
	
	
	protected void processSearch (String searchTerm) {
		BingSearch search = new BingSearch(searchTerm);
		List<BingAd> ads = search.ads();
		
		for (BingAd ad : ads)
			processAd(ad);
	}
	
	
	protected void processAd (BingAd ad) {
		logger.nextField(Integer.toString(linkID++));
		logger.nextField(ad.getClickTrackURL());
		logger.nextField(ad.getDestURL());
		compareWebsites(ad.getClickTrackURL(), ad.getDestURL());
		logger.nextField(Integer.toString(ad.sec1Length()));
		logger.writeLine();
	}
	
	
	protected void makeHeader() {
		logger.nextField("Key");
		logger.nextField("BingURL");
		logger.nextField("DestURL");
		logger.nextField("BingCode");
		logger.nextField("DestCode");
		logger.nextField("Diff");
		logger.nextField("Sec1Length");
		logger.writeLine();
	}

}
