package edu.ucf.rp2;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;

import org.apache.commons.lang3.StringUtils;

public class GoogleAd extends Ad {
	
	
	public GoogleAd (String googleURL) {
		clickTrackURL = googleURL;
	}
	
	
	protected String extractDestURL () {	
		// removes head from Google Ad URL
		String webUrl_coded = 
				clickTrackURL.substring(clickTrackURL.indexOf("adurl=")+6, clickTrackURL.length());
		// removes tail from Google Ad URL
		if (webUrl_coded.contains("&"))
		{
			webUrl_coded = webUrl_coded.substring(0, webUrl_coded.indexOf("&"));
		}
	    
		// splits the Google URL into substrings at each coded ASCII value
		String[] subStr = webUrl_coded.split("%");
		
		String webUrl_decoded = subStr[0];
		String asciiHex = "";
		String asciiSymbol = "";
		String convertedStr = "";
		   
		for(int j=1; j<subStr.length; j++)
		{
			// extract hex value from substring
			asciiHex = subStr[j].substring(0,2);
			// converts hex value to ASCII symbol
			asciiSymbol = hex2ascii(asciiHex);
			// replace hex value with ASCII symbol
			convertedStr = subStr[j].replace(asciiHex, asciiSymbol);
			// concatenates the string fragments into a final string
			webUrl_decoded = webUrl_decoded + convertedStr;
		}
		
		return webUrl_decoded;
	}
	
	
	public String getClickTrackURL () {
		if (!clickTrackURL.startsWith("http://")) {
			return "http://google.com" + clickTrackURL;
		} else {
			return clickTrackURL;
		}
	}
	
	
	public int sec1Length() {
		return clickTrackURL.indexOf("adurl=");
	}
	
	
	public String[] encodedChars() {
		String webUrl_coded = 
				clickTrackURL.substring(clickTrackURL.indexOf("adurl=")+6, clickTrackURL.length());
		// removes tail from Google Ad URL
		if (webUrl_coded.contains("&")) {
			webUrl_coded = webUrl_coded.substring(0, webUrl_coded.indexOf("&"));
		}
	    
		// splits the Google URL into substrings at each coded ASCII value
		String[] subStr = webUrl_coded.split("%");
		
		HashSet<String> hashTable = new HashSet<String>();
		for(int i=1; i<subStr.length; i++)
		{
			// extract hex value from substring
			String asciiHex = subStr[i].substring(0,2);
			hashTable.add(hex2ascii(asciiHex));
		}
		
		return hashTable.toArray(new String[hashTable.size()]);
	}
	
	
	public int numAmps () {
		// removes head from Google Ad URL
		String webUrl_coded = 
				clickTrackURL.substring(clickTrackURL.indexOf("adurl=")+6, clickTrackURL.length());
		
		return StringUtils.countMatches(webUrl_coded, "&");
	}
	
	
	public String[] sec3Parameters () {
		List<String> parameterList = new ArrayList<String>();
		
		String webUrl_coded = 
				clickTrackURL.substring(clickTrackURL.indexOf("adurl=")+6, clickTrackURL.length());
		
		int startIdx = webUrl_coded.length();
		int endIdx   = webUrl_coded.lastIndexOf("&", startIdx);
		
		while ( endIdx!=-1 )
		{
			parameterList.add(webUrl_coded.substring(endIdx+1, startIdx));
			startIdx = endIdx;
			endIdx   = webUrl_coded.lastIndexOf("&", startIdx-1);
		}
		
		return parameterList.toArray(new String[parameterList.size()]);
	}
		
}