package edu.ucf.rp2;

import java.io.FileWriter;
import java.io.IOException;
import java.util.List;



public class Test 
{
	
	
	
	public void google (String[] searchTerms) throws IOException
	{
		int      linkID          = 0;
		int      sec1Length      = 0;
		int      numAmps         = 0;
		String   googleURL       = null;
		String   destURL         = null;
		String   googleURLSource = null;
		String   destURLSource   = null;
		String[] sec3Parameters  = null; 
		double   percentDiff     = 0;
		
		FileWriter output = new FileWriter("Google.csv");
		output.write(googleHeader());
		
		for (String searchTerm : searchTerms)
		{
			GoogleSearch search = new GoogleSearch(searchTerm);
			List<GoogleAd> ads = search.ads();
			
			for (GoogleAd ad : ads)
			{
				linkID++;
				googleURL      = ad.getGoogleURL();
				destURL        = ad.getDestURL();
				numAmps        = ad.numAmps();
				sec1Length     = ad.sec1Length();
				sec3Parameters = ad.sec3Parameters();
				
				System.out.println("Processing link: " + linkID);
				
				try
				{
					System.out.println("\tAccesing: " + googleURL);
					googleURLSource = GoogleRedirectSource.getRedirect(googleURL);
					System.out.println("\tAccesing: " + destURL);
					destURLSource   = WebSource.get(destURL);
					System.out.println("\tComparing source");
					percentDiff     = DiffLines.perecentDiff(googleURLSource, destURLSource);
				}
				catch(IOException e)
				{
					percentDiff = -1;
				}
				
				output.write("\"" + linkID      + "\"" + ",");
				output.write("\"" + googleURL   + "\"" + ",");
				output.write("\"" + destURL     + "\"" + ",");
				output.write("\"" + percentDiff + "\"" + ",");
				output.write("\"" + searchTerm  + "\"" + ",");
				output.write("\"" + sec1Length  + "\"" + ",");
				output.write("\"" + numAmps     + "\"" + ",");
				for (int i=0; i<sec3Parameters.length; i++)
				{
					output.write("\"" + sec3Parameters[i] + "\"" + ",");
				}
				output.write("\n");
			}	
		}
		
		output.close();
	}
	
	
	
	private String googleHeader ()
	{
		return "Key"        + "," +
	           "GoogleURL"  + "," +
			   "DestURL"    + "," +
	           "Diff"       + "," +
			   "Search"     + "," +
	           "Sec1Length" + "," +
			   "NumAmps"    + "," +
			   "Parameters" + "\n";
	}
	
	
	
	public void bing (String[] searchTerms) throws IOException
	{
		int    linkID        = 0;
		int    sec1Length    = 0;
		String bingURL       = null;
		String destURL       = null;
		String bingURLSource = null;
		String destURLSource = null;
		double percentDiff   = 0;
		
		FileWriter output = new FileWriter("Bing.csv");
		output.write(bingHeader());
		
		for (String searchTerm : searchTerms)
		{
			BingSearch search = new BingSearch(searchTerm);
			List<BingAd> ads = search.ads();
			
			for (BingAd ad : ads)
			{
				linkID++;
				bingURL    = ad.getBingURL();
				destURL    = ad.destURL();
				sec1Length = ad.sec1Length();
				
				System.out.println("Processing link: " + linkID);
				
				try
				{
					System.out.println("\tAccesing: " + bingURL);
					bingURLSource = WebSource.get(bingURL);
					System.out.println("\tAccesing: " + destURL);
					destURLSource = WebSource.get(destURL);
					System.out.println("\tComparing source");
					percentDiff   = DiffLines.perecentDiff(bingURLSource, destURLSource);
				}
				catch(IOException e)
				{
					percentDiff = -1;
				}
				
				output.write("\"" + linkID      + "\"" + ",");
				output.write("\"" + bingURL     + "\"" + ",");
				output.write("\"" + destURL     + "\"" + ",");
				output.write("\"" + percentDiff + "\"" + ",");
				output.write("\"" + searchTerm  + "\"" + ",");
				output.write("\"" + sec1Length  + "\"" + "\n");
			}	
		}
		
		output.close();
	}
	
	
	
	private String bingHeader ()
	{
		return "Key"        + "," +
	           "BingURL"    + "," +
			   "DestURL"    + "," +
	           "Diff"       + "," +
			   "Search"     + "," +
	           "Sec1Length" + "\n";
	}
	
	
	
	public void yahoo (String[] searchTerms) throws IOException
	{
		int    linkID        = 0;
		int    sec1Length    = 0;
		String yahooURL       = null;
		String destURL       = null;
		String yahooURLSource = null;
		String destURLSource = null;
		double percentDiff   = 0;
		
		FileWriter output = new FileWriter("Yahoo.csv");
		output.write(yahooHeader());
		
		for (String searchTerm : searchTerms)
		{
			YahooSearch search = new YahooSearch(searchTerm);
			List<YahooAd> ads = search.ads();
			
			for (YahooAd ad : ads)
			{
				linkID++;
				yahooURL   = ad.adURL();
				destURL    = ad.destURL();
				sec1Length = ad.sec1Length();
				
				System.out.println("Processing link: " + linkID);
				
				try
				{
					System.out.println("\tAccesing: " + yahooURL);
					yahooURLSource = WebSource.get(yahooURL);
					System.out.println("\tAccesing: " + destURL);
					destURLSource = WebSource.get(destURL);
					System.out.println("\tComparing source");
					percentDiff   = DiffLines.perecentDiff(yahooURLSource, destURLSource);
				}
				catch(IOException e)
				{
					percentDiff = -1;
				}
				
				output.write("\"" + linkID      + "\"" + ",");
				output.write("\"" + yahooURL    + "\"" + ",");
				output.write("\"" + destURL     + "\"" + ",");
				output.write("\"" + percentDiff + "\"" + ",");
				output.write("\"" + searchTerm  + "\"" + ",");
				output.write("\"" + sec1Length  + "\"" + "\n");
				
			}	
		}
		
		output.close();
	}
	
	
	
	private String yahooHeader ()
	{
		return "Key"        + "," +
	           "YahooURL"   + "," +
			   "DestURL"    + "," +
	           "Diff"       + "," +
			   "Search"     + "," +
	           "Sec1Length" + "\n";
	}
	
	
	
}
